import type { InputNumberProps } from 'antd';
import React from 'react';
export declare type FieldMoneyProps = {
    text: number;
    moneySymbol?: boolean;
    locale?: string;
    placeholder?: any;
    customSymbol?: string;
    /** 自定义 Popover 的值，false 可以关闭他 */
    numberPopoverRender?: ((props: InputNumberProps, defaultText: string) => React.ReactNode) | boolean;
    /**
     * NumberFormat 的配置，文档可以查看 mdn
     *
     * @see https://developer.mozilla.org/zh-CN/docs/Web/JavaScript/Reference/Global_Objects/Intl/NumberFormat
     */
    numberFormatOptions?: {
        localeMatcher?: string;
        style?: string;
        currency?: string;
        currencyDisplay?: string;
        currencySign?: string;
        useGrouping?: boolean;
        minimumIntegerDigits?: number;
        minimumFractionDigits?: number;
        maximumFractionDigits?: number;
        minimumSignificantDigits?: number;
        maximumSignificantDigits?: number;
    };
};
declare const _default: React.ForwardRefExoticComponent<import("@ant-design/pro-provider").BaseProFieldFC & import("@ant-design/pro-provider").ProRenderFieldPropsType & FieldMoneyProps & React.RefAttributes<any>>;
export default _default;
