import type { BaseProFieldFC, ProFieldFCRenderProps, ProFieldRequestData, ProFieldTextType, ProFieldValueObjectType, ProFieldValueType, ProRenderFieldPropsType } from '@ant-design/pro-utils';
import React from 'react';
import FieldCode from './components/Code';
import FieldDatePicker from './components/DatePicker';
import FieldIndexColumn from './components/IndexColumn';
import type { FieldMoneyProps } from './components/Money';
import FieldMoney from './components/Money';
import FieldPercent from './components/Percent';
import FieldProgress from './components/Progress';
import FieldRangePicker from './components/RangePicker';
import FieldSelect, { proFieldParsingText, proFieldParsingValueEnumToArray } from './components/Select';
import FieldStatus from './components/Status';
import FieldText from './components/Text';
import FieldTimePicker from './components/TimePicker';
export declare type ProFieldMoneyProps = FieldMoneyProps;
export declare type ProFieldEmptyText = string | false;
/** 默认的 Field 需要实现的功能 */
export declare type ProFieldFC<T = {}> = React.ForwardRefRenderFunction<any, BaseProFieldFC & ProRenderFieldPropsType & T>;
/** 轻量筛选的field属性 */
export declare type ProFieldLightProps = {
    lightLabel?: React.RefObject<{
        labelRef: React.RefObject<HTMLElement>;
        clearRef: React.RefObject<HTMLElement>;
    }>;
    labelTrigger?: boolean;
};
/** Value type by function */
export declare type ProFieldValueTypeFunction<T> = (item: T) => ProFieldValueType | ProFieldValueObjectType;
declare type RenderProps = Omit<ProFieldFCRenderProps, 'text'> & ProRenderFieldPropsType & {
    /** 从服务器读取选项 */
    request?: ProFieldRequestData;
    emptyText?: React.ReactNode;
    visible?: boolean;
    onVisible?: (visible: boolean) => void;
    [key: string]: any;
};
/**
 * 根据不同的类型来转化数值
 *
 * @param dataValue
 * @param valueType
 */
declare const defaultRenderText: (dataValue: ProFieldTextType, valueType: ProFieldValueType | ProFieldValueObjectType, props: RenderProps, valueTypeMap: Record<string, ProRenderFieldPropsType>) => React.ReactNode;
export { defaultRenderText };
export { FieldPercent, FieldIndexColumn, FieldProgress, FieldMoney, FieldDatePicker, FieldRangePicker, FieldCode, FieldTimePicker, FieldText, FieldStatus, FieldSelect, proFieldParsingText, proFieldParsingValueEnumToArray, };
export type { ProFieldValueType, FieldMoneyProps };
/** ProField 的类型 */
export declare type ProFieldPropsType = {
    text?: ProFieldTextType;
    valueType?: ProFieldValueType | ProFieldValueObjectType;
} & RenderProps;
declare const _default: React.ForwardRefRenderFunction<any, ProFieldPropsType>;
export default _default;
