import type { ProFieldRequestData, ProFieldValueEnumType, ProSchemaValueEnumMap, RequestOptionsType } from '@ant-design/pro-utils';
import type { SelectProps } from 'antd';
import type { ReactNode } from 'react';
import React from 'react';
import type { ProFieldLightProps } from '../../index';
import './index.less';
declare type SelectOptionType = Partial<RequestOptionsType>[];
export declare type FieldSelectProps<FieldProps = any> = {
    text: string;
    /** 值的枚举，如果存在枚举，Search 中会生成 select */
    valueEnum?: ProFieldValueEnumType;
    /** 防抖动时间 默认10 单位ms */
    debounceTime?: number;
    /** 从服务器读取选项 */
    request?: ProFieldRequestData;
    /** 重新触发的时机 */
    params?: any;
    /** 组件的全局设置 */
    fieldProps?: FieldProps;
    bordered?: boolean;
    id?: string;
    children?: ReactNode;
} & ProFieldLightProps;
export declare const ObjToMap: (value: ProFieldValueEnumType | undefined) => ProSchemaValueEnumMap;
/**
 * 转化 text 和 valueEnum 通过 type 来添加 Status
 *
 * @param text
 * @param valueEnum
 * @param pure 纯净模式，不增加 status
 */
export declare const proFieldParsingText: (text: string | number | (string | number)[], valueEnumParams: ProFieldValueEnumType) => React.ReactNode;
/**
 * 把 value 的枚举转化为数组
 *
 * @param valueEnum
 */
export declare const proFieldParsingValueEnumToArray: (valueEnumParams: ProFieldValueEnumType) => SelectOptionType;
export declare const useFieldFetchData: (props: FieldSelectProps & {
    proFieldKey?: React.Key;
    defaultKeyWords?: string;
    cacheForSwr?: boolean;
}) => [boolean, SelectOptionType, (keyWord?: string) => void, () => void];
declare const _default: React.ForwardRefExoticComponent<import("@ant-design/pro-provider").BaseProFieldFC & import("@ant-design/pro-provider").ProRenderFieldPropsType & {
    text: string;
    /** 值的枚举，如果存在枚举，Search 中会生成 select */
    valueEnum?: ProFieldValueEnumType | undefined;
    /** 防抖动时间 默认10 单位ms */
    debounceTime?: number | undefined;
    /** 从服务器读取选项 */
    request?: ProFieldRequestData<any> | undefined;
    /** 重新触发的时机 */
    params?: any;
    /** 组件的全局设置 */
    fieldProps?: any;
    bordered?: boolean | undefined;
    id?: string | undefined;
    children?: ReactNode;
} & ProFieldLightProps & Pick<SelectProps<any, import("rc-select/lib/Select").DefaultOptionType>, "className" | "style" | "fieldNames"> & React.RefAttributes<any>>;
export default _default;
